## freedv 1.1

=== CMakeLists.txt ===
#
# FreeDV - HF Digital Voice for Radio Amateurs
#
# CMake configuration contributed by Richard Shaw (KF5OIM)
# Please report questions, comments, problems, or patches to the freetel
# mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
#

cmake_minimum_required(VERSION 2.8)

# Prevent in-source builds to protect automake/autoconf config.
# If an in-source build is attempted, you will still need to clean up a few
# files manually.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "   
   "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
   "separate build directory and run cmake from there.")
endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Set local module path.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(FreeDV)

#
# Set FreeDV version and generate src/version.h
#
set(FREEDV_VERSION_MAJOR 1)
set(FREEDV_VERSION_MINOR 1)
set(FREEDV_VERSION_PATCH FALSE)
set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
if(FREEDV_VERSION_PATCH)
    set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
endif()
set(FREEDV_VERSION_SUFFIX "")
if(FREEDV_VERSION_SUFFIX)
    set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
else()
    set(FREEDV_VERSION_STRING "${FREEDV_VERSION}")
endif()
message(STATUS "FreeDV version: ${FREEDV_VERSION_STRING}")
configure_file(cmake/version.h.in src/version.h @ONLY)

# Set default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS "Build type not specified, defaulting to ${CMAKE_BUILD_TYPE}")
endif(NOT CMAKE_BUILD_TYPE)


# Work around for not using a svn working copy.
add_definitions(-D_NO_AUTOTOOLS_)
find_program(SVNVERSION_PATH svnversion)
if(SVNVERSION_PATH)
    execute_process(COMMAND ${SVNVERSION_PATH} .
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE SVN_REVISION_RESULT
        OUTPUT_VARIABLE SVN_CURRENT_REVISION
        ERROR_QUIET
    )
else()
    set(SVN_REVISION_RESULT 1)
endif()
if(SVN_REVISION_RESULT EQUAL 0)
string(STRIP ${SVN_CURRENT_REVISION} SVN_REVISION)
add_definitions(-DSVN_REVISION="${SVN_REVISION}")
else()
add_definitions(-DSVN_REVISION="Unversioned directory")
endif()


# Set default build flags.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

#
# Setup cmake options
#
set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose makefile.")
set(USE_STATIC_DEPS FALSE CACHE BOOL 
    "Download and build static libraries instead of system libraries.")
set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL 
    "Download and build static portaudio instead of the system library.")
set(USE_STATIC_SNDFILE FALSE CACHE BOOL
    "Download and build static sndfile instead of the system library.")
set(USE_STATIC_SAMPLERATE FALSE CACHE BOOL
    "Download and build static samplerate instead of the system library.")
set(USE_STATIC_SOX FALSE CACHE BOOL
    "Download and build static sox instead of the system library.")
set(USE_STATIC_CODEC2 TRUE CACHE BOOL
    "Download and build static codec2 instead of the system library.")
set(USE_STATIC_SPEEXDSP TRUE CACHE BOOL
    "Download and build static speex instead of the system library.")
set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
    "Download and build static wxWidgets instead of the system library.")

if(USE_STATIC_DEPS)
    set(USE_STATIC_PORTAUDIO TRUE FORCE)
    set(USE_STATIC_SNDFILE TRUE FORCE)
    set(USE_STATIC_SAMPLERATE TRUE FORCE)
    set(USE_STATIC_SOX TRUE FORCE)
    set(USE_STATIC_CODEC2 TRUE FORCE)
endif(USE_STATIC_DEPS)

#
# Pull in external wxWidgets target if performing static build.
#
if(BOOTSTRAP_WXWIDGETS)
    message(STATUS "Adding wxWidgets build target...")
    include(cmake/BuildWxWidgets.cmake)
endif(BOOTSTRAP_WXWIDGETS)

#
# Perform bootstrap build of wxWidgets
#
if(BOOTSTRAP_WXWIDGETS AND NOT EXISTS ${WXCONFIG})
    message(STATUS "Will perform bootstrap build of wxWidgets.
   After make step completes, re-run cmake and make again to perform FreeDV build.")
#
# Continue normal build if not bootstrapping wxWidgets or is already built.
#
else(BOOTSTRAP_WXWIDGETS AND NOT EXISTS ${WXCONFIG})


#
# Various hacks and work arounds for building under MinGW.
#
if(MINGW)
    message(STATUS "System is MinGW.")
    # Setup HOST variable.
    include(cmake/MinGW.cmake)
    # This sets up the exe icon for windows under mingw.
    set(RES_FILES "")
    set(RES_FILES "${CMAKE_SOURCE_DIR}/contrib/freedv.rc")
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
        "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
    # These are DLOPEN'ed and can't be automatically pulled in by dependency.
    foreach(RUNTIME
        hamlib-adat.dll
        hamlib-alinco.dll
        hamlib-amsat.dll
        hamlib-aor.dll
        hamlib-ars.dll
        hamlib-celestron.dll
        hamlib-drake.dll
        hamlib-dummy.dll
        hamlib-easycomm.dll
        hamlib-flexradio.dll
        hamlib-fodtrack.dll
        hamlib-gs232a.dll
        hamlib-heathkit.dll
        hamlib-icom.dll
        hamlib-jrc.dll
        hamlib-kachina.dll
        hamlib-kenwood.dll
        hamlib-kit.dll
        hamlib-lowe.dll
        hamlib-m2.dll
        hamlib-pcr.dll
        hamlib-prm80.dll
        hamlib-racal.dll
        hamlib-rft.dll
        hamlib-rotorez.dll
        hamlib-rs.dll
        hamlib-sartek.dll
        hamlib-skanti.dll
        hamlib-spid.dll
        hamlib-tapr.dll
        hamlib-tentec.dll
        hamlib-ts7400.dll
        hamlib-tuner.dll
        hamlib-uniden.dll
        hamlib-winradio.dll
        hamlib-wj.dll
        hamlib-yaesu.dll)
        message(STATUS "Checking for ${RUNTIME}")
        find_library(${RUNTIME}_LIB ${RUNTIME}
            PATH_SUFFIXES hamlib)
        message(STATUS "runtime found: ${${RUNTIME}_LIB}")
        list(APPEND CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS ${${RUNTIME}_LIB})
    endforeach()
    include(InstallRequiredSystemLibraries)
endif(MINGW)

# Math library is automatic on MinGW
if(UNIX)
    set(CMAKE_REQUIRED_INCLUDES math.h)
    set(CMAKE_REQUIRED_LIBRARIES m)
endif(UNIX)

# Find some standard headers and functions.
include(CheckIncludeFiles)
check_include_files("limits.h" HAVE_LIMITS_H)
check_include_files("stddef.h" HAVE_STDDEF_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("string.h" HAVE_STRING_H)

include(CheckTypeSize)
check_type_size("int" SIZEOF_INT)

include(CheckFunctionExists)
check_function_exists(floor HAVE_FLOOR)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(pow HAVE_POW)
check_function_exists(sqrt HAVE_SQRT)

# fdmdv2_main.h requires patching to find config.h as it current looks in the
# source directory and the generated file goes in the binary directory.
configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                "${PROJECT_BINARY_DIR}/config.h" )
include_directories(${PROJECT_BINARY_DIR})
add_definitions(-DHAVE_CONFIG_H)

# Pthread Library
find_package(Threads REQUIRED)
message(STATUS "Threads library flags: ${CMAKE_THREAD_LIBS_INIT}")

#
# Find codec2
#
if(NOT USE_STATIC_CODEC2)
    message(STATUS "Looking for codec2...")
    # 'CONFIG' removed due to incompatibility with cmake version
    # in Ubuntu 12.04 (Precise) -- Stuart Longland
    find_package(codec2 QUIET)
    if(codec2_FOUND)
        get_target_property(CODEC2_LIBRARY codec2 LOCATION)
        message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
        message(STATUS "  codec2 headers: ${codec2_INCLUDE_DIRS}")
    else()
        # Try to find manually
        find_path(CODEC2_INCLUDE_DIRS codec2.h
                  PATH_SUFFIXES codec2)
        find_library(CODEC2_LIBRARY NAMES codec2)
        if(CODEC2_LIBRARY AND CODEC2_INCLUDE_DIRS)
            message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
            message(STATUS "  codec2 headers: ${CODEC2_INCLUDE_DIRS}")
            list(APPEND FREEDV_LINK_LIBS ${CODEC2_LIBRARY})
            include_directories(${CODEC2_INCLUDE_DIRS})
        else()
            message(FATAL_ERROR "codec2 library not found.
Linux: 
Codec2 may not be in your distribution so build yourself or use the cmake option to build statically into FreeDV.
Windws:
It's easiest to use the cmake option: USE_STATIC_CODEC2"
        )
        endif()
    endif()
else(NOT USE_STATIC_CODEC2)
    message(STATUS "Will attempt static build of codec2.")
    include(cmake/BuildCodec2.cmake)
endif(NOT USE_STATIC_CODEC2)

#
# Find or build portaudio Library
#
if(NOT USE_STATIC_PORTAUDIO)
    message(STATUS "Looking for portaudio...")
    find_package(Portaudio REQUIRED)
    if(PORTAUDIO_FOUND)
        message(STATUS "  portaudio library: ${PORTAUDIO_LIBRARIES}")
        message(STATUS "  portaudio headers: ${PORTAUDIO_INCLUDE_DIRS}")
        list(APPEND FREEDV_LINK_LIBS ${PORTAUDIO_LIBRARIES})
        include_directories(${PORTAUDIO_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "portaudio library not found.
On Linux systems try installing:
    portaudio-devel  (RPM based systems)
    libportaudio-dev (DEB based systems)
On Windows it's easiest to use the cmake option: USE_STATIC_PORTAUDIO"
        )
    endif()
    if(NOT ${PORTAUDIO_VERSION} EQUAL 19)
        message(WARNING "Portaudio versions other than 19 are known to have issues. You have been warned!")
    endif()
else(NOT USE_STATIC_PORTAUDIO)
    message(STATUS "Will attempt static build of portaudio.")
    include(cmake/BuildPortaudio.cmake)
endif(NOT USE_STATIC_PORTAUDIO)

#
# Hamlib library
#
message(STATUS "Looking for hamlib...")
find_path(HAMLIB_INCLUDE_DIR hamlib/rig.h)
find_library(HAMLIB_LIBRARY hamlib PATH_SUFFIXES hamlib)
message(STATUS "Hamlib library: ${HAMLIB_LIBRARY}")
message(STATUS "Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
if(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
    message(STATUS "Hamlib library found.")
    include_directories(${HAMLIB_INCLUDE_DIR})
    list(APPEND FREEDV_LINK_LIBS ${HAMLIB_LIBRARY})
else(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
    message(FATAL_ERROR "hamlib not found.
On Linux systems try installing:
    hamlib-devel  (RPM based systems)
    libhamlib-dev (DEB based systems)"
    )
endif(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)


#
# Samplerate Library
#
if(NOT USE_STATIC_SAMPLERATE)
    message(STATUS "Looking for samplerate...")
    find_library(LIBSAMPLERATE samplerate)
    find_path(LIBSAMPLERATE_INCLUDE_DIR samplerate.h)
    message(STATUS "  samplerate library: ${LIBSAMPLERATE}")
    message(STATUS "  samplerate headers: ${LIBSAMPLERATE_INCLUDE_DIR}")
    if(LIBSAMPLERATE AND LIBSAMPLERATE_INCLUDE_DIR)
        list(APPEND FREEDV_LINK_LIBS ${LIBSAMPLERATE})
        include_directories(${LIBSAMPLERATE_INCLUDE_DIR})
    else(LIBSTAMPLERATE AND LIBSAMPLERATE_INCLUDE_DIR)
        message(FATAL_ERROR "samplerate library not found.
On Linux systems try installing:
    samplerate-devel  (RPM based systems)
    libsamplerate-dev (DEB based systems)
On Windows it's easiest to use the cmake option: USE_STATIC_SAMPLERATE"
        )
    endif(LIBSAMPLERATE AND LIBSAMPLERATE_INCLUDE_DIR)
else(NOT USE_STATIC_SAMPLERATE)
    message(STATUS "Will attempt static build of samplerate.")
    include(cmake/BuildSamplerate.cmake)
endif(NOT USE_STATIC_SAMPLERATE)

#
# Find sox library
#
if(NOT USE_STATIC_SOX)
    message(STATUS "Looking for sox...")
    find_library(LIBSOX_LIBRARY sox)
    find_path(LIBSOX_INCLUDE_DIR NAMES sox/sox.h sox.h)
    message(STATUS "  sox library: ${LIBSOX_LIBRARY}")
    message(STATUS "  sox headers: ${LIBSOX_INCLUDE_DIR}")
    if(LIBSOX_LIBRARY AND LIBSOX_INCLUDE_DIR)
        list(APPEND FREEDV_LINK_LIBS ${LIBSOX_LIBRARY})
        include_directories(${LIBSOX_INCLUDE_DIR})
    else(LIBSOX_LIBRARY AND LIBSOX_INCLUDE_DIR)
        message(FATAL_ERROR "sox library not found.
On Linux systems try installing:
    sox-devel (RPM based systems)

=== contrib/CMakeLists.txt ===
# Install icons if we're on most *nix systems.
if(UNIX AND NOT APPLE)
    set(ICON_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor
        CACHE PATH "Prefix to use for installing icons.")
    install(FILES freedv48x48.png
        DESTINATION ${ICON_INSTALL_PREFIX}/48x48/apps
        RENAME freedv.png)
    install(FILES freedv64x64.png
        DESTINATION ${ICON_INSTALL_PREFIX}/64x64/apps
        RENAME freedv.png)
    install(FILES freedv128x128.png
        DESTINATION ${ICON_INSTALL_PREFIX}/128x128/apps
        RENAME freedv.png)
    install(FILES freedv256x256.png
        DESTINATION ${ICON_INSTALL_PREFIX}/256x256/apps
        RENAME freedv.png)

    set(DESKTOP_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/applications
        CACHE PATH "Location to install desktop files.")
    install(FILES freedv.desktop
        DESTINATION ${DESKTOP_INSTALL_DIR})
endif(UNIX AND NOT APPLE)

=== src/CMakeLists.txt ===
set(FREEDV_SOURCES
    dlg_audiooptions.cpp
    dlg_filter.cpp
    dlg_options.cpp
    dlg_ptt.cpp
    fdmdv2_main.cpp
    fdmdv2_pa_wrapper.cpp
    fdmdv2_plot.cpp
    fdmdv2_plot_scalar.cpp
    fdmdv2_plot_scatter.cpp
    fdmdv2_plot_spectrum.cpp
    fdmdv2_plot_waterfall.cpp
    hamlib.cpp
    topFrame.cpp
    sox_biquad.c
    comp.h
    dlg_audiooptions.h
    dlg_filter.h
    dlg_options.h
    dlg_ptt.h
    fdmdv2_defines.h
    fdmdv2_main.h
    fdmdv2_pa_wrapper.h
    fdmdv2_plot.h
    fdmdv2_plot_scalar.h
    fdmdv2_plot_scatter.h
    fdmdv2_plot_spectrum.h
    fdmdv2_plot_waterfall.h
    hamlib.h
    sox_biquad.h
    sox.h
    topFrame.h
    version.h
)

# WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES})
target_link_libraries(freedv ${FREEDV_LINK_LIBS})
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
if(FREEDV_STATIC_DEPS)
    add_dependencies(freedv ${FREEDV_STATIC_DEPS})
endif(FREEDV_STATIC_DEPS)
install(TARGETS freedv
    RUNTIME DESTINATION bin)

# Custom commands to build OSX images.
if(APPLE)
    add_custom_command(
        TARGET freedv
        POST_BUILD
        COMMAND mkdir ARGS -p FreeDV.app/Contents/MacOS
        COMMAND mkdir ARGS -p FreeDV.app/Contents/Resources/English.lproj
        COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/info.plist FreeDV.app/Contents
        COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/freedv.icns FreeDV.app/Contents/Resources
        COMMAND echo ARGS -n "APPL????" > FreeDV.app/Contents/PkgInfo
        COMMAND cp ARGS freedv FreeDV.app/Contents/MacOS/FreeDV
        COMMAND dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @executable_path/../libs/
        COMMAND mkdir dist_tmp
        COMMAND cp -r FreeDV.app dist_tmp
        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO ./FreeDV.dmg
        COMMAND rm -rf dist_tmp
    )
endif(APPLE)

=== debian/changelog ===
freedv (1.1-1) unstable; urgency=medium

  * New upstream release, new Voice Keyer feature
  * consistent 8000 Hz audio I/O sample rate. (requires codec2 >= 0.5)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 25 Sep 2015 23:22:18 -0400

freedv (1.0-1) unstable; urgency=low

  * New upstream release
  * New source package name, following upstream conventions

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 01 Sep 2015 23:08:27 -0400

fdmdv2 (0.96.6.1592-1) unstable; urgency=low

  * New upstream 0.96.6 tagged release r1592

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 08 May 2014 19:32:42 -0400

fdmdv2 (0.96.5.1353-1) experimental; urgency=low

  * Upstream subversion r1353
  * build-depend upon libwxgtk3.0-dev (Closes: #735959)
    remove wxwidgets tarball from source (Closes: #735942, #736002)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 19 Jan 2014 15:25:41 -0500

fdmdv2 (0.96.5.1328-1) experimental; urgency=low

  * New upstream subversion r1328 (AKA 0.96.5 Beta)
  * Update wxWidgets 2.9.5 version
  * cleanup source - see debian/rules get-orig-source, (Closes: #706184)
  * HID-PTT patch included

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 30 Aug 2013 23:16:27 -0400

fdmdv2 (0.96.1-1) experimental; urgency=low

  * FreeDV.org Dayton 2013 packages
  * New upstream subversion r1247

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 11 May 2013 10:43:03 -0400

fdmdv2 (0.0.1235-1) experimental; urgency=low

  * New upstream svn r1235 (Closes: #706184)
  * Fancy source package for single binary freedv package for Wheezy
  * HID-PTT patch included

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 26 Apr 2013 20:44:30 -0400

=== debian/control ===
Source: freedv
Section: hamradio
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9~),
               libcodec2-dev (>= 0.5),
               libhamlib-dev,
               libsamplerate-dev,
               libsndfile-dev,
               libsox-dev,
               libspeexdsp-dev,
               libwxgtk3.0-dev,
               portaudio19-dev
Standards-Version: 3.9.6
Homepage: http://freedv.org/
Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-freedv.git
Vcs-Browser: http://anonscm.debian.org/cgit/users/bottoms/pkg-freedv.git/

Package: freedv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Software Defined Radio (SDR)
 FreeDV is a digital voice mode intended for transmission and
 reception over high-frequency (HF) radio. It uses a frequency
 division multiplex (FDM) modem with 15 carriers and no forward error
 correction (FEC). A low bit-rate voice coder-decoder (Codec 2)
 provides voice quality without the listener fatigue caused by noise
 and interference normally associated with analog single sideband
 (SSB) voice. A HF SSB transceiver, personal computer and two sound
 cards are required. Path simulation and on-the-air HF testing have
 shown that decoding voice is possible at a signal-to-noise ratio of
 4 dB.
 .
 The FreeDV software was developed by David Rowe (Codec 2, FDM
 modem implementation, integration) and David Witten (GUI,
 architecture design). The FreeDV design and user interface was based
 on the earlier FDMDV program which was developed by Francesco
 Lanza. The FDM modem design and development was supported from Peter
 Martinez.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddir=Build --build-system=cmake

override_dh_auto_configure:
	dh_auto_configure --builddirectory=Build --buildsystem=cmake -- -DUSE_STATIC_CODEC2=False -DUSE_STATIC_SPEEXDSP=False

false_override_dh_auto_install:
	dh_auto_install
	/usr/bin/install --mode=0644 -D contrib/freedv.desktop debian/freedv/usr/share/applications/freedv.desktop
	for r in 48x48 64x64 128x128 256x256 ; do /usr/bin/install --mode=0644 -D contrib/freedv$$r.png debian/freedv/usr/share/icons/hicolor/$$r/apps/freedv.png ; done

## freedv 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,8 @@
 # Please report questions, comments, problems, or patches to the freetel
 # mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
 #
+
+set(CMAKE_OSX_DEPLOYMENT_TARGET "10.7" CACHE STRING "Minimum OS X deployment version")
 
 cmake_minimum_required(VERSION 2.8)
 
@@ -28,13 +30,13 @@
 # Set FreeDV version and generate src/version.h
 #
 set(FREEDV_VERSION_MAJOR 1)
-set(FREEDV_VERSION_MINOR 1)
-set(FREEDV_VERSION_PATCH FALSE)
+set(FREEDV_VERSION_MINOR 2)
+set(FREEDV_VERSION_PATCH 2)
 set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
 if(FREEDV_VERSION_PATCH)
     set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
 endif()
-set(FREEDV_VERSION_SUFFIX "")
+set(FREEDV_VERSION_SUFFIX FALSE)
 if(FREEDV_VERSION_SUFFIX)
     set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
 else()
@@ -45,16 +47,15 @@
 
 # Set default build type
 if(NOT CMAKE_BUILD_TYPE)
-    set(CMAKE_BUILD_TYPE "Release")
+    set(CMAKE_BUILD_TYPE "Debug")
     message(STATUS "Build type not specified, defaulting to ${CMAKE_BUILD_TYPE}")
 endif(NOT CMAKE_BUILD_TYPE)
 
-
 # Work around for not using a svn working copy.
 add_definitions(-D_NO_AUTOTOOLS_)
-find_program(SVNVERSION_PATH svnversion)
-if(SVNVERSION_PATH)
-    execute_process(COMMAND ${SVNVERSION_PATH} .
+find_program(SVN_PATH svn)
+if(SVN_PATH)
+    execute_process(COMMAND ${SVN_PATH} info --show-item revision
         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
         RESULT_VARIABLE SVN_REVISION_RESULT
         OUTPUT_VARIABLE SVN_CURRENT_REVISION
@@ -63,16 +64,21 @@
 else()
     set(SVN_REVISION_RESULT 1)
 endif()
+
 if(SVN_REVISION_RESULT EQUAL 0)
-string(STRIP ${SVN_CURRENT_REVISION} SVN_REVISION)
-add_definitions(-DSVN_REVISION="${SVN_REVISION}")
+    string(STRIP ${SVN_CURRENT_REVISION} SVN_REVISION)
+    add_definitions(-DSVN_REVISION="${SVN_REVISION}")
 else()
-add_definitions(-DSVN_REVISION="Unversioned directory")
+    add_definitions(-DSVN_REVISION="None")
 endif()
 
 
 # Set default build flags.
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
+if(APPLE)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -std=c++11")
+endif(APPLE)
 
 #
 # Setup cmake options
@@ -86,8 +92,6 @@
     "Download and build static sndfile instead of the system library.")
 set(USE_STATIC_SAMPLERATE FALSE CACHE BOOL
     "Download and build static samplerate instead of the system library.")
-set(USE_STATIC_SOX FALSE CACHE BOOL
-    "Download and build static sox instead of the system library.")
 set(USE_STATIC_CODEC2 TRUE CACHE BOOL
     "Download and build static codec2 instead of the system library.")
 set(USE_STATIC_SPEEXDSP TRUE CACHE BOOL
@@ -99,7 +103,6 @@
     set(USE_STATIC_PORTAUDIO TRUE FORCE)
     set(USE_STATIC_SNDFILE TRUE FORCE)
     set(USE_STATIC_SAMPLERATE TRUE FORCE)
-    set(USE_STATIC_SOX TRUE FORCE)
     set(USE_STATIC_CODEC2 TRUE FORCE)
 endif(USE_STATIC_DEPS)
 
@@ -137,51 +140,6 @@
     enable_language(RC)
     set(CMAKE_RC_COMPILE_OBJECT
         "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
-    # These are DLOPEN'ed and can't be automatically pulled in by dependency.
-    foreach(RUNTIME
-        hamlib-adat.dll
-        hamlib-alinco.dll
-        hamlib-amsat.dll
-        hamlib-aor.dll
-        hamlib-ars.dll
-        hamlib-celestron.dll
-        hamlib-drake.dll
-        hamlib-dummy.dll
-        hamlib-easycomm.dll
-        hamlib-flexradio.dll
-        hamlib-fodtrack.dll
-        hamlib-gs232a.dll
-        hamlib-heathkit.dll
-        hamlib-icom.dll
-        hamlib-jrc.dll
-        hamlib-kachina.dll
-        hamlib-kenwood.dll
-        hamlib-kit.dll
-        hamlib-lowe.dll
-        hamlib-m2.dll
-        hamlib-pcr.dll
-        hamlib-prm80.dll
-        hamlib-racal.dll
-        hamlib-rft.dll
-        hamlib-rotorez.dll
-        hamlib-rs.dll
-        hamlib-sartek.dll
-        hamlib-skanti.dll
-        hamlib-spid.dll
-        hamlib-tapr.dll
-        hamlib-tentec.dll
-        hamlib-ts7400.dll
-        hamlib-tuner.dll
-        hamlib-uniden.dll
-        hamlib-winradio.dll
-        hamlib-wj.dll
-        hamlib-yaesu.dll)
-        message(STATUS "Checking for ${RUNTIME}")
-        find_library(${RUNTIME}_LIB ${RUNTIME}
-            PATH_SUFFIXES hamlib)
-        message(STATUS "runtime found: ${${RUNTIME}_LIB}")
-        list(APPEND CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS ${${RUNTIME}_LIB})
-    endforeach()
     include(InstallRequiredSystemLibraries)
 endif(MINGW)
 
@@ -193,10 +151,16 @@
 
 # Find some standard headers and functions.
 include(CheckIncludeFiles)
-check_include_files("limits.h" HAVE_LIMITS_H)
-check_include_files("stddef.h" HAVE_STDDEF_H)
-check_include_files("stdlib.h" HAVE_STDLIB_H)
-check_include_files("string.h" HAVE_STRING_H)
+check_include_files("byteswap.h"   HAVE_BYTESWAP_H)
+check_include_files("limits.h"     HAVE_LIMITS_H)
+check_include_files("stddef.h"     HAVE_STDDEF_H)
+check_include_files("stdlib.h"     HAVE_STDLIB_H)
+check_include_files("string.h"     HAVE_STRING_H)
+check_include_files("strings.h"    HAVE_STRINGS_H)
+check_include_files("ltdl.h"       HAVE_LTDL_H)
+check_include_files("inttypes.h"   HAVE_INTTYPES_H)
+check_include_files("sys/stat.h"   HAVE_SYS_STAT_H)
+check_include_files("sys/types.h"  HAVE_SYS_TYPES_H)
 
 include(CheckTypeSize)
 check_type_size("int" SIZEOF_INT)
@@ -206,6 +170,13 @@
 check_function_exists(memset HAVE_MEMSET)
 check_function_exists(pow HAVE_POW)
 check_function_exists(sqrt HAVE_SQRT)
+check_function_exists(fseeko HAVE_FSEEKO)
+check_function_exists(fmemopen HAVE_FMEMOPEN)
+check_function_exists(strcasecmp HAVE_STRCASECMP)
+check_function_exists(vsnprintf HAVE_VSNPRINTF)
+
+include(CheckSymbolExists)
+check_symbol_exists("_fseeki64" "stdio.h" HAVE__FSEEKI64)
 
 # fdmdv2_main.h requires patching to find config.h as it current looks in the
 # source directory and the generated file goes in the binary directory.
@@ -213,6 +184,10 @@
                 "${PROJECT_BINARY_DIR}/config.h" )
 include_directories(${PROJECT_BINARY_DIR})
 add_definitions(-DHAVE_CONFIG_H)
+
+# Config file for bundled sox sources
+configure_file("${PROJECT_SOURCE_DIR}/cmake/soxconfig.h.in"
+               "${PROJECT_BINARY_DIR}/soxconfig.h")
 
 # Pthread Library
 find_package(Threads REQUIRED)
@@ -327,19 +302,33 @@
     include(cmake/BuildSamplerate.cmake)
 endif(NOT USE_STATIC_SAMPLERATE)
 
-#
-# Find sox library
-#
-if(NOT USE_STATIC_SOX)
-    message(STATUS "Looking for sox...")
-    find_library(LIBSOX_LIBRARY sox)
-    find_path(LIBSOX_INCLUDE_DIR NAMES sox/sox.h sox.h)
-    message(STATUS "  sox library: ${LIBSOX_LIBRARY}")
-    message(STATUS "  sox headers: ${LIBSOX_INCLUDE_DIR}")
-    if(LIBSOX_LIBRARY AND LIBSOX_INCLUDE_DIR)
-        list(APPEND FREEDV_LINK_LIBS ${LIBSOX_LIBRARY})
-        include_directories(${LIBSOX_INCLUDE_DIR})
-    else(LIBSOX_LIBRARY AND LIBSOX_INCLUDE_DIR)
-        message(FATAL_ERROR "sox library not found.
+#    
+# sndfile Library
+#
+if(NOT USE_STATIC_SNDFILE)
+    message(STATUS "Looking for sndfile...")
+    find_library(LIBSNDFILE sndfile)
+    find_path(LIBSNDFILE_INCLUDE_DIR sndfile.h)
+    message(STATUS "  sndfile library: ${LIBSNDFILE}")
+    message(STATUS "  sndfile headers: ${LIBSNDFILE_INCLUDE_DIR}")
+    if(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
+        list(APPEND FREEDV_LINK_LIBS ${LIBSNDFILE})
+    else(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
+        message(FATAL_ERROR "sndfile library not found.
 On Linux systems try installing:
-    sox-devel (RPM based systems)
+    libsndfile-devel (RPM based systems)
+    libsndfile-dev   (DEB based systems)
+On Windows it's easiest to use the cmake option: USE_STATIC_SNDFILE"
+        )
+    endif(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
+else(NOT USE_STATIC_SNDFILE)
+    message(STATUS "Will attempt static build of sndfile.")
+    include(cmake/BuildSndfile.cmake)
+endif(NOT USE_STATIC_SNDFILE)
+
+#
+# Find wxWidgets
+#
+if(NOT BOOTSTRAP_WXWIDGETS)
+    set(WXCONFIG "" CACHE FILEPATH "Location of wx-config binary.")
+    set(WXRC "" CACHE FILEPATH "Location of wxrc binary.")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
     dlg_filter.cpp
     dlg_options.cpp
     dlg_ptt.cpp
+    dlg_plugin.cpp
     fdmdv2_main.cpp
     fdmdv2_pa_wrapper.cpp
     fdmdv2_plot.cpp
@@ -11,6 +12,7 @@
     fdmdv2_plot_spectrum.cpp
     fdmdv2_plot_waterfall.cpp
     hamlib.cpp
+    serialport.cpp
     topFrame.cpp
     sox_biquad.c
     comp.h
@@ -28,7 +30,21 @@
     fdmdv2_plot_waterfall.h
     hamlib.h
     sox_biquad.h
-    sox.h
+    sox/band.h
+    sox/biquad.c
+    sox/biquads.c
+    sox/biquad.h
+    sox/effects.c
+    sox/effects.h
+    sox/effects_i.c
+    sox/formats_i.c
+    sox/libsox.c
+    sox/sox.h
+    sox/sox_i.h
+    sox/soxomp.h
+    sox/util.h
+    sox/xmalloc.h
+    sox/xmalloc.c
     topFrame.h
     version.h
 )

=== debian/changelog ===
freedv (1.2.2-3) unstable; urgency=medium

  * Use local sox biquad filter code (Closes: #882203)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 27 Nov 2017 23:39:59 -0500

freedv (1.2.2-2) unstable; urgency=medium

  * Better Description, omit unnecessary link with libXxf86vm

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 04 Sep 2017 12:35:18 -0400

freedv (1.2.2-1) unstable; urgency=medium

  * New upstream release, using new modes in codec2 0.7
    Improvements to Hamlib support, error message reporting, serial rate box.
    Disabled unused UDP comms/egexp processing to clean up Options dialog.
  * include AppStream metadata Comment in desktop file (LP: #1646467)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 15 Aug 2017 22:38:34 -0400

freedv (1.2-1) experimental; urgency=medium

  * New upstream release
  * http://www.rowetel.com/?p=5456

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 15 Feb 2017 22:10:13 -0500

freedv (1.1.0.3026-1) experimental; urgency=low

  * New upstream experimental trials - svn 3026
  * Highlights: FreeDV 1.2 / Codec2 0.6 test release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 29 Jan 2017 16:07:00 -0500

=== debian/control ===
Source: freedv
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9~),
	       libcodec2-dev (>= 0.7),
               libhamlib-dev,
               libsamplerate-dev,
               libsndfile-dev,
               libspeexdsp-dev,
               libwxgtk3.0-dev,
               portaudio19-dev
Standards-Version: 4.1.1
Homepage: http://freedv.org/
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-hamradio/freedv.git/
Vcs-Git: git://anonscm.debian.org/pkg-hamradio/freedv.git

Package: freedv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: digital voice mode for HF radio
 FreeDV is a digital voice mode intended for transmission and
 reception over high-frequency (HF) radio. It uses about half the
 bandwidth of traditional analog single-sideband (SSB) voice. A low
 bit-rate voice coder-decoder (Codec 2) provides voice quality without
 the listener fatigue caused by noise and interference normally
 associated with analog single sideband (SSB) voice. A HF SSB
 transceiver, personal computer and two sound cards are required. Path
 simulation and on-the-air HF testing have shown that decoding voice
 is possible at a signal-to-noise ratio of 4 dB.
 .
 The FreeDV software was developed by David Rowe (Codec 2, FDM
 modem implementation, integration) and David Witten (GUI,
 architecture design). The FreeDV design and user interface was based
 on the earlier FDMDV program which was developed by Francesco
 Lanza. The FDM modem design and development was supported from Peter
 Martinez.

=== debian/watch ===
version=3
 https://files.freedv.org/freedv/ freedv-(.+)\.tar\.xz

## freedv 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,13 +30,14 @@
 # Set FreeDV version and generate src/version.h
 #
 set(FREEDV_VERSION_MAJOR 1)
-set(FREEDV_VERSION_MINOR 2)
-set(FREEDV_VERSION_PATCH 2)
+set(FREEDV_VERSION_MINOR 3)
+set(FREEDV_VERSION_PATCH 1)
+set(FREEDV_VERSION_SUFFIX FALSE)
+
 set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
 if(FREEDV_VERSION_PATCH)
     set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
 endif()
-set(FREEDV_VERSION_SUFFIX FALSE)
 if(FREEDV_VERSION_SUFFIX)
     set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
 else()
@@ -47,27 +48,27 @@
 
 # Set default build type
 if(NOT CMAKE_BUILD_TYPE)
-    set(CMAKE_BUILD_TYPE "Debug")
+    set(CMAKE_BUILD_TYPE "Release")
     message(STATUS "Build type not specified, defaulting to ${CMAKE_BUILD_TYPE}")
 endif(NOT CMAKE_BUILD_TYPE)
 
 # Work around for not using a svn working copy.
 add_definitions(-D_NO_AUTOTOOLS_)
-find_program(SVN_PATH svn)
-if(SVN_PATH)
-    execute_process(COMMAND ${SVN_PATH} info --show-item revision
-        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-        RESULT_VARIABLE SVN_REVISION_RESULT
-        OUTPUT_VARIABLE SVN_CURRENT_REVISION
-        ERROR_QUIET
-    )
-else()
-    set(SVN_REVISION_RESULT 1)
-endif()
-
-if(SVN_REVISION_RESULT EQUAL 0)
-    string(STRIP ${SVN_CURRENT_REVISION} SVN_REVISION)
-    add_definitions(-DSVN_REVISION="${SVN_REVISION}")
+
+#
+# Find the svn revision if this is a working copy.
+#
+get_filename_component(_src_dir "${CMAKE_SOURCE_DIR}" NAME)
+if("${_src_dir}" STREQUAL "freedv-dev")
+    find_package(Subversion QUIET)
+    if(Subversion_FOUND)
+        Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} FREEDV)
+        message(STATUS "FreeDV svn revision: ${FREEDV_WC_REVISION}")
+        add_definitions(-DSVN_REVISION="${FREEDV_WC_REVISION}")
+    else(Subversion_FOUND)
+        message(WARNING "Subversion not found. Can not determine svn revision.")
+        add_definitions(-DSVN_REVISION="Unknown")
+    endif(Subversion_FOUND)
 else()
     add_definitions(-DSVN_REVISION="None")
 endif()
@@ -94,7 +95,7 @@
     "Download and build static samplerate instead of the system library.")
 set(USE_STATIC_CODEC2 TRUE CACHE BOOL
     "Download and build static codec2 instead of the system library.")
-set(USE_STATIC_SPEEXDSP TRUE CACHE BOOL
+set(USE_STATIC_SPEEXDSP FALSE CACHE BOOL
     "Download and build static speex instead of the system library.")
 set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
     "Download and build static wxWidgets instead of the system library.")
@@ -131,6 +132,9 @@
 #
 if(MINGW)
     message(STATUS "System is MinGW.")
+    # Default to static build of portaudio until I can figure out why the
+    # shared DLL doesn't work.
+    set(USE_STATIC_PORTAUDIO TRUE)
     # Setup HOST variable.
     include(cmake/MinGW.cmake)
     # This sets up the exe icon for windows under mingw.
@@ -196,6 +200,27 @@
 #
 # Find codec2
 #
+if(CODEC2_BUILD_DIR)
+    set(USE_STATIC_CODEC2 OFF CACHE BOOL "" FORCE)
+    message(STATUS "Using codec2 from build directory...")
+    get_filename_component(CODEC2_BUILD_DIR ${CODEC2_BUILD_DIR} 
+        ABSOLUTE BASE_DIR ${CMAKE_BINARY_DIR})
+    message(STATUS "  Build include dir: ${CODEC2_BUILD_DIR}")
+    load_cache(${CODEC2_BUILD_DIR} codec2_SOURCE_DIR)
+    find_path(CODEC2_SOURCE_INCLUDE_DIR codec2.h
+        PATHS ${codec2_SOURCE_DIR}
+        PATH_SUFFIXES src
+        NO_DEFAULT_PATH)
+    message(STATUS "  Source include dir: ${CODEC2_SOURCE_INCLUDE_DIR}")
+    find_library(CODEC2_LIBRARY NAMES codec2
+        PATHS ${CODEC2_BUILD_DIR}
+        PATH_SUFFIXES src
+        NO_DEFAULT_PATH)
+    message(STATUS "  Library: ${CODEC2_LIBRARY}")
+    list(APPEND FREEDV_LINK_LIBS ${CODEC2_LIBRARY})
+    include_directories(${CODEC2_SOURCE_INCLUDE_DIR}
+        ${CODEC2_BUILD_DIR})
+else(CODEC2_BUILD_DIR)
 if(NOT USE_STATIC_CODEC2)
     message(STATUS "Looking for codec2...")
     # 'CONFIG' removed due to incompatibility with cmake version
@@ -228,6 +253,8 @@
     message(STATUS "Will attempt static build of codec2.")
     include(cmake/BuildCodec2.cmake)
 endif(NOT USE_STATIC_CODEC2)
+endif(CODEC2_BUILD_DIR)
+
 
 #
 # Find or build portaudio Library
@@ -248,7 +275,7 @@
 On Windows it's easiest to use the cmake option: USE_STATIC_PORTAUDIO"
         )
     endif()
-    if(NOT ${PORTAUDIO_VERSION} EQUAL 19)
+    if(NOT ${PORTAUDIO_VERSION} EQUAL 19 AND NOT MINGW)
         message(WARNING "Portaudio versions other than 19 are known to have issues. You have been warned!")
     endif()
 else(NOT USE_STATIC_PORTAUDIO)
@@ -262,8 +289,8 @@
 message(STATUS "Looking for hamlib...")
 find_path(HAMLIB_INCLUDE_DIR hamlib/rig.h)
 find_library(HAMLIB_LIBRARY hamlib PATH_SUFFIXES hamlib)
-message(STATUS "Hamlib library: ${HAMLIB_LIBRARY}")
-message(STATUS "Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
+message(STATUS "  Hamlib library: ${HAMLIB_LIBRARY}")
+message(STATUS "  Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
 if(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
     message(STATUS "Hamlib library found.")
     include_directories(${HAMLIB_INCLUDE_DIR})
@@ -298,37 +325,3 @@
         )
     endif(LIBSAMPLERATE AND LIBSAMPLERATE_INCLUDE_DIR)
 else(NOT USE_STATIC_SAMPLERATE)
-    message(STATUS "Will attempt static build of samplerate.")
-    include(cmake/BuildSamplerate.cmake)
-endif(NOT USE_STATIC_SAMPLERATE)
-
-#    
-# sndfile Library
-#
-if(NOT USE_STATIC_SNDFILE)
-    message(STATUS "Looking for sndfile...")
-    find_library(LIBSNDFILE sndfile)
-    find_path(LIBSNDFILE_INCLUDE_DIR sndfile.h)
-    message(STATUS "  sndfile library: ${LIBSNDFILE}")
-    message(STATUS "  sndfile headers: ${LIBSNDFILE_INCLUDE_DIR}")
-    if(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
-        list(APPEND FREEDV_LINK_LIBS ${LIBSNDFILE})
-    else(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
-        message(FATAL_ERROR "sndfile library not found.
-On Linux systems try installing:
-    libsndfile-devel (RPM based systems)
-    libsndfile-dev   (DEB based systems)
-On Windows it's easiest to use the cmake option: USE_STATIC_SNDFILE"
-        )
-    endif(LIBSNDFILE AND LIBSNDFILE_INCLUDE_DIR)
-else(NOT USE_STATIC_SNDFILE)
-    message(STATUS "Will attempt static build of sndfile.")
-    include(cmake/BuildSndfile.cmake)
-endif(NOT USE_STATIC_SNDFILE)
-
-#
-# Find wxWidgets
-#
-if(NOT BOOTSTRAP_WXWIDGETS)
-    set(WXCONFIG "" CACHE FILEPATH "Location of wx-config binary.")
-    set(WXRC "" CACHE FILEPATH "Location of wxrc binary.")

=== debian/changelog ===
freedv (1.3.1-3) unstable; urgency=medium

  * Change VCS links to salsa

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 11 Aug 2018 21:47:07 -0400

freedv (1.3.1-2) unstable; urgency=medium

  * noise fix from 10 June 2018
  "FreeDV 1.3.1 shipped with a noise simulator turned on by accident.
  Injected noise to create a 2 dB SNR.
  Despite this many people were working long-range communications!"

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 11 Aug 2018 19:20:08 -0400

freedv (1.3.1-1) unstable; urgency=medium

  * New upstream release
  * support codec2 0.8.1 (Closes: #903225)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 16 Jul 2018 22:52:22 -0400

freedv (1.3-1) unstable; urgency=medium

  * New upstream release
  * new 700D mode

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 27 May 2018 09:00:07 -0400

=== debian/control ===
Source: freedv
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9~),
	       libcodec2-dev (>= 0.8.1),
               libhamlib-dev,
               libsamplerate-dev,
               libsndfile-dev,
               libspeexdsp-dev,
               libwxgtk3.0-dev,
               portaudio19-dev
Standards-Version: 4.1.4
Homepage: http://freedv.org/
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/freedv.git

Package: freedv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Software Defined Radio (SDR)
 FreeDV is a digital voice mode intended for transmission and
 reception over high-frequency (HF) radio. It uses a frequency
 division multiplex (FDM) modem with 15 carriers and no forward error
 correction (FEC). A low bit-rate voice coder-decoder (Codec 2)
 provides voice quality without the listener fatigue caused by noise
 and interference normally associated with analog single sideband
 (SSB) voice. A HF SSB transceiver, personal computer and two sound
 cards are required. Path simulation and on-the-air HF testing have
 shown that decoding voice is possible at a signal-to-noise ratio of
 4 dB.
 .
 The FreeDV software was developed by David Rowe (Codec 2, FDM
 modem implementation, integration) and David Witten (GUI,
 architecture design). The FreeDV design and user interface was based
 on the earlier FDMDV program which was developed by Francesco
 Lanza. The FDM modem design and development was supported from Peter
 Martinez.

=== debian/watch ===
version=3
 https://hobbes1069.fedorapeople.org/freetel/freedv/ freedv-(.+)\.tar\.xz

## freedv 1.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -51,13 +51,29 @@
 
 # WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
 add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES})
-target_link_libraries(freedv ${FREEDV_LINK_LIBS})
-include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
+
+# Link imported or build tree targets.
+target_link_libraries(freedv codec2 lpcnetfreedv)
+
+# Add build dependencies for interally built external libraries.
+if(USE_INTERNAL_CODEC2)
+    add_dependencies(freedv build_codec2 build_lpcnetfreedv)
+endif()
+
+# Add depenencies for other statically built libraries, if applicable.
 if(FREEDV_STATIC_DEPS)
     add_dependencies(freedv ${FREEDV_STATIC_DEPS})
 endif(FREEDV_STATIC_DEPS)
+
+# Link other dependencies
+target_link_libraries(freedv ${FREEDV_LINK_LIBS})
+
+# Insert source and generated header directories before other search directories.
+include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
+
 install(TARGETS freedv
-    RUNTIME DESTINATION bin)
+    RUNTIME DESTINATION bin
+)
 
 # Custom commands to build OSX images.
 if(APPLE)
@@ -70,10 +86,10 @@
         COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/freedv.icns FreeDV.app/Contents/Resources
         COMMAND echo ARGS -n "APPL????" > FreeDV.app/Contents/PkgInfo
         COMMAND cp ARGS freedv FreeDV.app/Contents/MacOS/FreeDV
-        COMMAND dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @executable_path/../libs/
+        COMMAND DYLD_LIBRARY_PATH=${CODEC2_BUILD_DIR}/src:${LPCNET_BUILD_DIR}/src:${DYLD_LIBRARY_PATH} ${CMAKE_SOURCE_DIR}/macdylibbundler/dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @loader_path/../libs/
         COMMAND mkdir dist_tmp
         COMMAND cp -r FreeDV.app dist_tmp
-        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO ./FreeDV.dmg
+        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO -fs HFS+ ./FreeDV.dmg
         COMMAND rm -rf dist_tmp
     )
 endif(APPLE)

=== debian/changelog ===
freedv (1.4-2) unstable; urgency=medium

  * Acknowledge NMU and rebuild without buggy AVX instruction test
  * Point watch file at github.com/drowe67/freedv-gui

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 17 Feb 2020 12:42:28 -0500

freedv (1.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Put x86 specific code behind ifdefs (Closes: 947828).

 -- Peter Michael Green <plugwash@debian.org>  Tue, 07 Jan 2020 10:09:41 +0000

freedv (1.4-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 17 Nov 2019 22:32:07 -0500

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Uploaders: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: cmake,
                debhelper (>= 9~),
-	       libcodec2-dev (>= 0.8.1),
+	       libcodec2-dev (>= 0.9),
                libhamlib-dev,
                libsamplerate-dev,
                libsndfile-dev,
                libspeexdsp-dev,
-               libwxgtk3.0-dev,
+               libwxgtk3.0-gtk3-dev,
                portaudio19-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.4.0
 Homepage: http://freedv.org/
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/freedv.git

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%freedv_$1.orig.tar.gz%" \
 https://github.com/drowe67/freedv-gui/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
